unit utrigo ;

interface

  function grad ( bm : real) : real ;
  function bogen ( w : real ) : real ;
  function arcsin (x : real ) : real ; {Gibt w in bogenmass zurck}
  function arccos (x : real ) : real ; {    "  }
  function cossatzwinkel (s1,s3,s2 : real ) : real ;  { bogenma}
  function cossatzgegenseite (s1,w3,s2 : real ) : real ;  { " }

  {bei den Dreiecksprozeduren entsprechen die eingehenden Parameter den
   Stcken des entsprechenden Kongruenzsatzes, das erste ausgehende Stck
   liegt dem ersten eingehenden Stck gegenber, das zweite ausgehende
   dem zweiten eingehenden etc}

  procedure sss (s1,s2,s3:real; var w1,w2,w3 : real) ;
  procedure sws (s1,w2,s3:real; var w1,s2,w3 : real) ;
  procedure wsw (w1,s2,w3:real; var s1,w2,s3 : real) ;

implementation

  function grad ( bm : real) : real ;
    begin
      grad := (bm*180)/Pi ;
    end; {grad}

  function bogen ( w : real ) : real ;
    begin
      bogen := (w*Pi)/180 ;
    end; {bogen}

  function arcsin (x : real ) : real ; {Gibt w in bogenmass zurck}
    begin
      If x = 1 Then arcsin := Pi/2
               else arcsin:= arctan ( x/sqrt(1-x*x) ) ;
    end; {arcsin}

  function arccos (x : real ) : real ; {    "  }
  var w : real ;
    begin
      If x = 0 THEN arccos := Pi/2
      else
        begin
           w := arctan ( sqrt(1-x*x) / x ) ;
           if w < 0 then w := Pi + w ;
           arccos := w ;
        end ;
    end; {arccos}

  function cossatzwinkel (s1,s3,s2 : real ) : real ;
  var cc : real ;
    begin
      cc := ( sqr(s1) + sqr(s2) - sqr(s3) ) / (2 * s1 * s2 ) ;
      cossatzwinkel := arccos ( cc ) ;
    end ; {}

  function cossatzgegenseite (s1,w3,s2 : real ) : real ;
    begin
      cossatzgegenseite := sqrt (sqr(s1) + sqr(s2) - 2*s1*s2* cos (w3)) ;
    end ; {}


  procedure sss (s1,s2,s3:real; var w1,w2,w3 : real) ;
  var cosw : real ;
    begin
      w1 := grad ( cossatzwinkel (s2,s1,s3) ) ;
      w2 := grad ( cossatzwinkel (s1,s2,s3) ) ;
      w3 := 180 - w1 - w2 ;
    end ; {sss}

  procedure sws (s1,w2,s3:real; var w1,s2,w3 : real) ;
    begin
      s2 := cossatzgegenseite ( s1 , bogen(w2) , s3 ) ;
      w1 := grad ( cossatzwinkel (s2,s1,s3) ) ;
      w3 := 180 - w1 - w2 ;
    end ; {sws}

  procedure wsw (w1,s2,w3:real; var s1,w2,s3 : real) ;
    begin
      w2 := 180 - w1 - w3 ;
      s1 := ( sin ( bogen ( w1) ) * s2 ) / sin ( bogen ( w2 ) ) ;
      s3 := ( sin ( bogen ( w3) ) * s2 ) / sin ( bogen ( w2 ) ) ;
    end ; {wsw}



end.